<?php

/**
 * สำหรับเกมส์ โยกังเท่านั้น (Yulgang Only)
 * ใช้สำหรับเรียก Callback เมื่อเติมเงินสำเร็จ
 */

error_reporting(E_ERROR);

$_CONFIG["DB_HOST"] =   ""; // Host Name เช่น DESKTOP-2GT784M
$_CONFIG["DB_USER"] =   ""; // Username เช่น sa
$_CONFIG["DB_PWD"]  =   ""; // Password
$_CONFIG["DB_NAME"] =   ""; // Database Name เช่น Yulgang

$PaymentObj = new RankPayment(file_get_contents('php://input'), $_CONFIG["DB_HOST"], $_CONFIG["DB_NAME"], $_CONFIG["DB_USER"], $_CONFIG["DB_PWD"]);

class RankPayment
{
    private $SQLInstance = NULL;
    private $InputBody;
    private $Data;

    function __construct($InputData, $SQL_HOST, $SQL_DBNAME, $SQL_USER, $SQL_PWD)
    {
        date_default_timezone_set('Asia/Bangkok');

        $this->VerifyAddr();
        $this->InputBody = $InputData;
        $this->VerifyData();
        $this->InitialiseDatabase($SQL_HOST, $SQL_DBNAME, $SQL_USER, $SQL_PWD);
        $this->Process();
    }

    private function InitialiseDatabase($SQL_HOST, $SQL_DBNAME, $SQL_USER, $SQL_PWD)
    {
        function InitialiseTable($SQLObject)
        {
            $Query = "
            IF OBJECT_ID(N'dbo.RANK_PAYMENT', N'U') IS NULL
            BEGIN
                CREATE TABLE [dbo].[RANK_PAYMENT](
                    [ID] [int] IDENTITY(1,1) NOT NULL,
                    [ACCOUNT_ID] [int] NOT NULL,
                    [USER_ID] [varchar](50) NOT NULL,
                    [AMOUNT] [int] NOT NULL,
                    [POINT] [int] NOT NULL,
                    [POINT_BONUS] [int] NOT NULL,
                    [TRANSACTION_ID] [varchar](20) NOT NULL,
                    [CREATED] [datetime] NOT NULL
                ) ON [PRIMARY]
                
                ALTER TABLE [dbo].[RANK_PAYMENT] ADD  CONSTRAINT [DF_RANK_PAYMENT_CREATED]  DEFAULT (GETDATE()) FOR [CREATED]
            END";
            return mssql_query($Query, $SQLObject);
        }

        $this->SQLInstance = mssql_connect($SQL_HOST, $SQL_USER, $SQL_PWD);

        if (!$this->SQLInstance)
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "Error: การเชื่อมต่อ Database ผิดผลาด"));
        }

        if (!mssql_select_db($SQL_DBNAME, $this->SQLInstance))
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "Error: การเลือก Database ผิดผลาด"));
        }

        if (!InitialiseTable($this->SQLInstance))
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "Error: การสร้าง Table ผิดผลาด"));
        }
    }

    private function IsJSON($str)
    {
        return json_decode($str) != null;
    }

    private function GetClientAddress()
    {
        function Internal_AddrIsInRange($ip, $range)
        {
            if (strpos($range, '/') == false)
                $range .= '/32';

            list($range, $netmask) = explode('/', $range, 2);
            $range_decimal = ip2long($range);
            $ip_decimal = ip2long($ip);
            $wildcard_decimal = pow(2, (32 - $netmask)) - 1;
            $netmask_decimal = ~$wildcard_decimal;
            return (($ip_decimal & $netmask_decimal) == ($range_decimal & $netmask_decimal));
        }

        function Internal_CfCheckAddr($ip)
        {
            $cf_ips = array(
                '173.245.48.0/20',
                '103.21.244.0/22',
                '103.22.200.0/22',
                '103.31.4.0/22',
                '141.101.64.0/18',
                '108.162.192.0/18',
                '190.93.240.0/20',
                '188.114.96.0/20',
                '197.234.240.0/22',
                '198.41.128.0/17',
                '162.158.0.0/15',
                '104.16.0.0/13',
                '104.24.0.0/14',
                '172.64.0.0/13',
                '131.0.72.0/22',
            );

            $is_cf_ip = false;
            foreach ($cf_ips as $cf_ip)
            {
                if (Internal_AddrIsInRange($ip, $cf_ip))
                {
                    $is_cf_ip = true;
                    break;
                }
            }
            return $is_cf_ip;
        }

        function Internal_CfCheckRequest()
        {
            $flag = true;

            if (!isset($_SERVER['HTTP_CF_CONNECTING_IP']))   $flag = false;
            if (!isset($_SERVER['HTTP_CF_IPCOUNTRY']))       $flag = false;
            if (!isset($_SERVER['HTTP_CF_RAY']))             $flag = false;
            if (!isset($_SERVER['HTTP_CF_VISITOR']))         $flag = false;
            return $flag;
        }

        function IsCloudflare()
        {
            $ipCheck        = Internal_CfCheckAddr($_SERVER['REMOTE_ADDR']);
            $requestCheck   = Internal_CfCheckRequest();
            return ($ipCheck && $requestCheck);
        }

        $IsCF = IsCloudflare();

        if ($IsCF)
        {
            return $_SERVER['HTTP_CF_CONNECTING_IP'];
        }
        else
        {
            return $_SERVER['REMOTE_ADDR'];
        }
    }

    private function VerifyAddr()
    {
        if (md5($this->GetClientAddress()) != "7030eb342ba7f67efac041ae8d3abb23")
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "Access denied: Invalid client address."));
        }
    }

    private function VerifyData()
    {
        if (!$this->IsJSON($this->InputBody))
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "Error: ข้อมูลที่ได้รับมาไม่ใช่ JSON"));
        }

        $this->Data = json_decode($this->InputBody, true);
    }

    private function escape($data)
    {
        if (is_int($data))
        {
            return $data;
        }

        if (!isset($data) || empty($data)) return '';

        $non_displayables = array(
            '/%0[0-8bcef]/',
            '/%1[0-9a-f]/',
            '/[\x00-\x08]/',
            '/\x0b/',
            '/\x0c/',
            '/[\x0e-\x1f]/'
        );

        foreach ($non_displayables as $regex)
        {
            $data = preg_replace($regex, '', $data);
        }

        $data = str_replace("'", "''", $data);
        return $data;
    }

    private function GetAccountID($Username)
    {
        $Username = $this->escape($Username);

        $QueryStmt = "SELECT ID FROM [DBO].[TBL_ACCOUNT] WHERE FLD_ID = '$Username'";

        $result = mssql_query($QueryStmt, $this->SQLInstance);

        if ($result === false)
        {
            throw new Exception("Could not execute statement GetAccountID");
        }

        $num_rows = mssql_num_rows($result);

        if ($num_rows <= 0)
        {
            return false;
        }

        $row = mssql_fetch_assoc($result);
        return $row["ID"];
    }

    private function IsRefExist($refNo)
    {
        $refNo = $this->escape($refNo);

        $QueryStmt = "SELECT 1 FROM [DBO].[RANK_PAYMENT] WHERE TRANSACTION_ID = '$refNo'";

        $result = mssql_query($QueryStmt, $this->SQLInstance);

        if ($result === false)
        {
            throw new Exception("Could not execute statement IsRefExist");
        }

        $num_rows = mssql_num_rows($result);
        return (int)$num_rows > 0;
    }

    private function InsertData($GameID, $AccountID, $Amount, $Point, $Bonus, $refNo)
    {
        $GameID     = $this->escape($GameID);
        $AccountID  = $this->escape($AccountID);
        $Amount     = $this->escape($Amount);
        $Point      = $this->escape($Point);
        $Bonus      = $this->escape($Bonus);
        $refNo      = $this->escape($refNo);

        $QueryStmt = "INSERT INTO [DBO].[RANK_PAYMENT](ACCOUNT_ID, USER_ID, AMOUNT, POINT, POINT_BONUS, TRANSACTION_ID) VALUES ('$AccountID', '$GameID', '$Amount', '$Point', '$Bonus', '$refNo')";

        $result = mssql_query($QueryStmt, $this->SQLInstance);

        if ($result === false)
        {
            throw new Exception("Could not execute statement InsertData");
        }

        $row_affected = mssql_rows_affected($this->SQLInstance);
        return (int)$row_affected > 0;
    }

    private function UpdatePoint($AccountID, $Point, $Bonus, $Amount)
    {
        $AccountID  = $this->escape($AccountID);
        $Point      = $this->escape($Point);
        $Bonus      = $this->escape($Bonus);
        $Amount     = $this->escape($Amount);

        $QueryStmt = "UPDATE [DBO].[TBL_ACCOUNT] SET FLD_RXPIONT += '$Point', FLD_RXPIONTX += '$Bonus', FLD_SUM_DONATE += '$Amount' WHERE ID = '$AccountID'";

        $result = mssql_query($QueryStmt, $this->SQLInstance);

        if ($result === false)
        {
            throw new Exception("Could not execute statement UpdatePoint");
        }

        $row_affected = mssql_rows_affected($this->SQLInstance);
        return (int)$row_affected > 0;
    }

    private function Process()
    {
        try
        {
            switch ($this->Data["action"])
            {
                case "CheckServer":
                    $this->ExitWithJSON(array("status" => 0, "message" => "The server is operational."));
                    break;
                case "CheckUser":
                    {
                        if (!array_key_exists("username", $this->Data))
                        {
                            $this->ExitWithJSON(array("status" => 1, "message" => "The 'username' field is missing in the provided JSON."));
                        }

                        $AccountID = $this->GetAccountID($this->Data["username"]);

                        if ($AccountID === false)
                        {
                            $this->ExitWithJSON(array("status" => 1, "message" => "ไม่สามารถค้นหาไอดีนี้ได้ โปรดตรวจสอบ"));
                        }

                        $this->ExitWithJSON(array("status" => 0, "message" => "สำเร็จ", "account_id" => $AccountID));
                    }
                    break;
                case "TOPUP":
                    {
                        if (
                            !array_key_exists("GameID", $this->Data) ||
                            !array_key_exists("Amount", $this->Data) ||
                            !array_key_exists("Point", $this->Data) ||
                            !array_key_exists("Bonus", $this->Data) ||
                            !array_key_exists("ItemData", $this->Data) ||
                            !array_key_exists("TransactionID", $this->Data)
                        )
                        {
                            $this->ExitWithJSON(array("status" => 1, "message" => "ได้รับข้อมูลไม่ครบ โปรดตรวจสอบ"));
                        }

                        if ($this->IsRefExist($this->Data["TransactionID"]))
                        {
                            $this->ExitWithJSON(array("status" => 0, "message" => "มี Transaction นี้อยู่แล้ว การเติมเงินสำเร็จ"));
                        }

                        $AccountID = $this->GetAccountID($this->Data["GameID"]);

                        if ($AccountID === false)
                        {
                            $this->ExitWithJSON(array("status" => 1, "message" => "ไม่สามารถค้นหาไอดีได้หรือไอดีไม่มีอยู่จริงโปรดตรวจสอบ"));
                        }

                        if (mssql_query("BEGIN TRANSACTION", $this->SQLInstance) === false)
                        {
                            $this->ExitWithJSON(array("status" => 1, "message" => "การทำงานของ Database ผิดผลาด โปรดติดต่อทีมงาน"));
                        }

                        $UpdatePoint    = $this->UpdatePoint($AccountID, $this->Data["Point"], $this->Data["Bonus"], $this->Data["Amount"]);
                        $InsertData     = $this->InsertData(
                            $this->Data["GameID"],
                            $AccountID,
                            $this->Data["Amount"],
                            $this->Data["Point"],
                            $this->Data["Bonus"],
                            $this->Data["TransactionID"]
                        );

                        if ($UpdatePoint && $InsertData)
                        {
                            mssql_query("COMMIT", $this->SQLInstance);
                            $this->ExitWithJSON(array("status" => 0, "message" => "การเติมเงินสำเร็จ!"));
                        }
                        else
                        {
                            mssql_query("ROLLBACK", $this->SQLInstance);
                            $this->ExitWithJSON(array("status" => 1, "message" => "การเติมเงินไม่สำเร็จ โปรดติดต่อทีมงาน"));
                        }
                    }
                    break;
            }
        }
        catch (Exception $e)
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "ผิดผลาด โปรดติดต่อทีมงาน ข้อความ " . $e->getMessage()));
        }
    }

    private function ExitWithJSON($data)
    {
        header("Content-Type: application/json");
        exit(json_encode($data));
    }
}